unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  ExtCtrls, StdCtrls, VBScript_RegExp_55_TLB, JPEG, Gifimg;

type
  TForm3 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Image1: TImage;
    Label3: TLabel;
    Edit2: TEdit;
    Button3: TButton;
    Label4: TLabel;
    Edit3: TEdit;
    IdHTTP1: TIdHTTP;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure IdHTTP1Redirect(Sender: TObject; var dest: string;
      var NumRedirect: Integer; var Handled: Boolean; var VMethod: string);
    procedure Button2Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;
  CaptchaKey: string;
  webmaster: Boolean;
  Error: Boolean;
  ErrorText: string;

implementation

{$R *.dfm}

procedure TForm3.Button1Click(Sender: TObject);
var
  List: TStringList;
  R: TRegExp;
  mc: MatchCollection;
  m: Match;
  sm: SubMatches;
  Stream: TMemoryStream;
  JPEG: TJPEGImage;
begin
  webmaster := true;
  List := TStringList.Create;
  List.Text := IdHTTP1.Get('http://webmaster.yandex.ru/');
  //     
  R := TRegExp.Create(self);
  R.Pattern := 'src="(.*?key=(.*?))"'; //     Captcha
  R.Multiline := true;
  R.IgnoreCase := true;
  R.Global := true;
  mc := R.Execute(List.Text) as MatchCollection;
  if mc.Count > 0 then //  
  begin
    m := mc[0] as Match;
    sm := m.SubMatches as SubMatches;
    Stream := TMemoryStream.Create;
    IdHTTP1.Get(sm[0], Stream); //    .
    CaptchaKey := sm[1]; //   Captcha
    R := nil;
    m := nil;
    mc := nil;
    Stream.Position := 0; //    
    JPEG := TJPEGImage.Create; //  jpeg
    JPEG.LoadFromStream(Stream); //    
    Image1.Picture.Assign(JPEG); //   Image
  end;
end;

procedure TForm3.Button2Click(Sender: TObject);
var
  ResultList: TStringList;
  rnd: Integer;
  List: TStringList;
  R: TRegExp;
  mc: MatchCollection;
  m: Match;
  sm: SubMatches;
  Stream: TMemoryStream;
  Gif: TGIFImage;
begin
  ResultList := TStringList.Create;
  //   rnd
  Randomize;
  rnd := round(777) * 777;
  //  
  ResultList.Text := IdHTTP1.Get('http://narod.ru/disk/getcapchaxml/?rnd=');
  R := TRegExp.Create(self);
  R.Pattern := 'url="(.*?)">(.*?)</number>'; //     Captcha
  R.Multiline := true;
  R.IgnoreCase := true;
  R.Global := true;
  mc := R.Execute(ResultList.Text) as MatchCollection;
  if mc.Count > 0 then //  
  begin
    m := mc[0] as Match;
    sm := m.SubMatches as SubMatches;
    Stream := TMemoryStream.Create;
    IdHTTP1.Get(sm[0], Stream); //    .
    CaptchaKey:= sm[1]; //   Captcha
    R := nil;
    m := nil;
    mc := nil;
    Stream.Position := 0; //    
    //   -  gif,    
    GIF:=TGIFImage.Create;
    Gif.LoadFromStream(Stream);
    Image1.Picture.Assign(Gif.Bitmap); //   Image
  end;
end;

procedure TForm3.Button3Click(Sender: TObject);
var
  ParamList: TStringList;
  R: TRegExp;
  mc: MatchCollection;
  m: Match;
  sm: SubMatches;
begin
  Error := false;
  ParamList := TStringList.Create; //     
  if webmaster then
  begin
    ParamList.Add('url=' + Edit1.Text);
    ParamList.Add('key=' + CaptchaKey);
    ParamList.Add('rep=' + Edit2.Text);
    ParamList.Add('');
    with IdHTTP1.Request do
    begin
      URL := 'http://webmaster.yandex.ru/add.xml';
      Host := 'webmaster.yandex.ru';
      UserAgent :=
        'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.1.3) Gecko/20090824 Firefox/3.5.3';
      Accept :=
        'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8';
      AcceptLanguage := 'ru,en-us;q=0.7,en;q=0.3';
      AcceptEncoding := 'gzip,deflate';
      AcceptCharSet := 'windows-1251,utf-8;q=0.7,*;q=0.7';
      Connection := 'keep-alive';
      Referer := 'http://webmaster.yandex.ru/';
      ContentLength := Length(ParamList.Text);
      ContentType := 'application/x-www-form-urlencoded';
    end;
    ParamList.Text := IdHTTP1.Post('http://webmaster.yandex.ru/add.xml',
      ParamList);
  end
  else
  begin
    ParamList.Add('key='+CaptchaKey);
    ParamList.Add('action=sendcapcha');
    ParamList.Add('rep='+Edit2.Text);
    ParamList.Text:=IdHTTP1.Post(Edit1.Text,ParamList);
    //   
    if pos('http://img.yandex.net/i/z.gif',ParamList.Text)>0 then
      begin
        Error:=true;
        ErrorText:='  Captcha';
        Button2Click(self);//   
      end
    else
      begin
        //   ,          
        R := TRegExp.Create(self);
        R.Pattern := 'href="(.*?)">'+Edit1.text+'</a>'; //     Captcha
        R.Multiline := true;
        R.IgnoreCase := true;
        R.Global := true;
        mc := R.Execute(ParamList.Text) as MatchCollection;
        if mc.Count > 0 then //  
          begin
            m := mc[0] as Match;
            sm := m.SubMatches as SubMatches;
            Edit3.Text:='http://narod.ru'+sm[0];// 
            R := nil;
            m := nil;
            mc := nil;
          end;
      end;
  end;
  if Error then
  begin
    Edit3.Text := ErrorText;
    Button1Click(self);
  end
  else
    if webmaster then
      Edit3.Text := '  '
end;

procedure TForm3.IdHTTP1Redirect(Sender: TObject; var dest: string;
  var NumRedirect: Integer; var Handled: Boolean; var VMethod: string);
begin
if webmaster then
  begin
  //   ,  100%  
  Error := true;
  if pos('CAPTCHA_FAILD', dest) > 0 then
    ErrorText := '   Captcha'
  else if pos('INVALID_URL', dest) > 0 then
    ErrorText := '  URL'
  else if pos('URL_RETURNED_WRONG_CODE', dest) > 0 then
    ErrorText :=
      ' ,     http,   200'
  else if pos('HOST_IS_MIRROR_MAIN_MIRROR_IS_INDEXED', dest) > 0 then
    ErrorText :=
      '      .     '
  else if pos('URL_IS_ALREADY_INDEXED', dest) > 0 then
    ErrorText := '  ';
  end
else
  begin
    Memo1.Lines.Add(dest)
  end;
end;

end.
